Index: XIOS/dev/branch_openmp/extern/remap/src/mpi_routing.cpp
===================================================================
--- XIOS/dev/branch_openmp/extern/remap/src/mpi_routing.cpp	(revision 1288)
+++ XIOS/dev/branch_openmp/extern/remap/src/mpi_routing.cpp	(revision 1289)
@@ -127,6 +127,8 @@
 	MPI_Info info_null;
 
-	MPI_Alloc_mem(nbTarget *sizeof(int), info_null, &targetRank);
-	MPI_Alloc_mem(nbSource *sizeof(int), info_null, &sourceRank);
+	// MPI_Alloc_mem(nbTarget *sizeof(int), info_null, &targetRank);
+	// MPI_Alloc_mem(nbSource *sizeof(int), info_null, &sourceRank);
+	MPI_Alloc_mem(nbTarget *sizeof(int), MPI_INFO_NULL, &targetRank);
+	MPI_Alloc_mem(nbSource *sizeof(int), MPI_INFO_NULL, &sourceRank);
 
 	targetRankToIndex = new int[mpiSize];
Index: XIOS/dev/branch_openmp/extern/remap/src/polyg.cpp
===================================================================
--- XIOS/dev/branch_openmp/extern/remap/src/polyg.cpp	(revision 1288)
+++ XIOS/dev/branch_openmp/extern/remap/src/polyg.cpp	(revision 1289)
@@ -180,5 +180,5 @@
 		assert(sc >= -1e-10); // Error: tri a l'env (wrong orientation)
 		double area_gc = triarea(t[0], t[1], t[2]);
-		if(area_gc<=0) printf("area_gc = %e\n", area_gc);
+		//if(area_gc<=0) printf("area_gc = %e\n", area_gc);
 		double area_sc_gc_moon = 0;
 		if (d[i]) /* handle small circle case */
Index: XIOS/dev/branch_openmp/extern/src_ep_dev/ep_allgatherv.cpp
===================================================================
--- XIOS/dev/branch_openmp/extern/src_ep_dev/ep_allgatherv.cpp	(revision 1288)
+++ XIOS/dev/branch_openmp/extern/src_ep_dev/ep_allgatherv.cpp	(revision 1289)
@@ -62,10 +62,10 @@
 
     MPI_Gather_local(&sendcount, 1, MPI_INT, local_recvcounts.data(), 0, comm);
-    for(int i=1; i<num_ep; i++) local_displs[i] = local_displs[i-1] + local_recvcounts[i]; 
+    for(int i=1; i<num_ep; i++) local_displs[i] = local_displs[i-1] + local_recvcounts[i-1]; 
 
 
     if(is_master)
     {
-      local_recvbuf = new void*[datasize * num_ep * count];
+      local_recvbuf = new void*[datasize * std::accumulate(local_recvcounts.begin(), local_recvcounts.end(), 0)];
       tmp_recvbuf = new void*[datasize * std::accumulate(recvcounts, recvcounts+ep_size, 0)];
     }
@@ -81,5 +81,5 @@
       std::vector<int>mpi_displs(mpi_size, 0);
 
-      int local_sendcount = num_ep * count;
+      int local_sendcount = std::accumulate(local_recvcounts.begin(), local_recvcounts.end(), 0);
       MPI_Allgather(&local_sendcount, 1, MPI_INT, mpi_recvcounts.data(), 1, MPI_INT, to_mpi_comm(comm.mpi_comm));
 
@@ -99,5 +99,5 @@
 
 
-      ::MPI_Allgatherv(local_recvbuf, num_ep * count, to_mpi_type(datatype), tmp_recvbuf, mpi_recvcounts.data(), mpi_displs.data(), to_mpi_type(datatype), to_mpi_comm(comm.mpi_comm));
+      ::MPI_Allgatherv(local_recvbuf, local_sendcount, to_mpi_type(datatype), tmp_recvbuf, mpi_recvcounts.data(), mpi_displs.data(), to_mpi_type(datatype), to_mpi_comm(comm.mpi_comm));
 
       // if(ep_rank == 0)
Index: XIOS/dev/branch_openmp/extern/src_ep_dev/ep_alltoall.cpp
===================================================================
--- XIOS/dev/branch_openmp/extern/src_ep_dev/ep_alltoall.cpp	(revision 1288)
+++ XIOS/dev/branch_openmp/extern/src_ep_dev/ep_alltoall.cpp	(revision 1289)
@@ -1,62 +1,26 @@
 #include "ep_lib.hpp"
 #include <mpi.h>
-#include "ep_mpi.hpp"
-
+//#include "ep_declaration.hpp"
 
 namespace ep_lib
 {
 
+
+
   int MPI_Alltoall(const void *sendbuf, int sendcount, MPI_Datatype sendtype, void *recvbuf, int recvcount, MPI_Datatype recvtype, MPI_Comm comm)
   {
-    if(!comm.is_ep)
-    {
-      return ::MPI_Alltoall(sendbuf, sendcount, to_mpi_type(sendtype), recvbuf, recvcount, to_mpi_type(recvtype), to_mpi_comm(comm.mpi_comm));
-    }
+    assert(static_cast< ::MPI_Datatype>(sendtype) == static_cast< ::MPI_Datatype>(recvtype));
+    ::MPI_Aint typesize, llb;
+    ::MPI_Type_get_extent(static_cast< ::MPI_Datatype>(sendtype), &llb, &typesize);
+    
+    int ep_size;
+    MPI_Comm_size(comm, &ep_size);
+    
 
-
-    assert(valid_type(sendtype) && valid_type(recvtype));
-    assert(sendcount == recvcount);
-
-    ::MPI_Aint datasize, llb;
-    ::MPI_Type_get_extent(static_cast< ::MPI_Datatype>(sendtype), &llb, &datasize);
-
-    int count = sendcount;
-    
-    int ep_rank = comm.ep_comm_ptr->size_rank_info[0].first;
-    int ep_rank_loc = comm.ep_comm_ptr->size_rank_info[1].first;
-    int mpi_rank = comm.ep_comm_ptr->size_rank_info[2].first;
-    int ep_size = comm.ep_comm_ptr->size_rank_info[0].second;
-    int num_ep = comm.ep_comm_ptr->size_rank_info[1].second;
-    int mpi_size = comm.ep_comm_ptr->size_rank_info[2].second;
-
-    void* tmp_recvbuf;
-    if(ep_rank == 0) tmp_recvbuf = new void*[count * ep_size * ep_size * datasize];
-
-    MPI_Gather(sendbuf, count*ep_size, sendtype, tmp_recvbuf, count*ep_size, recvtype, 0, comm);
-
-    
-    
-    // reorder tmp_buf
-    void* tmp_sendbuf;
-    if(ep_rank == 0) tmp_sendbuf = new void*[count * ep_size * ep_size * datasize];
-
-    if(ep_rank == 0)
     for(int i=0; i<ep_size; i++)
     {
-      for(int j=0; j<ep_size; j++)
-      {
-        //printf("tmp_recv[%d] = tmp_send[%d]\n", i*ep_size*count + j*count, j*ep_size*count + i*count);
-
-        memcpy(tmp_sendbuf + j*ep_size*count*datasize + i*count*datasize, tmp_recvbuf + i*ep_size*count*datasize + j*count*datasize, count*datasize);
-      }
+      ep_lib::MPI_Gather(sendbuf+i*sendcount*typesize, sendcount, sendtype, recvbuf, recvcount, recvtype, i, comm);
     }
-
-    MPI_Scatter(tmp_sendbuf, ep_size*count, sendtype, recvbuf, ep_size*recvcount, recvtype, 0, comm);
-
-    if(ep_rank == 0)
-    {
-      delete[] tmp_recvbuf;
-      delete[] tmp_sendbuf;
-    }
+    
 
     return 0;
Index: XIOS/dev/branch_openmp/extern/src_ep_dev/ep_bcast.cpp
===================================================================
--- XIOS/dev/branch_openmp/extern/src_ep_dev/ep_bcast.cpp	(revision 1288)
+++ XIOS/dev/branch_openmp/extern/src_ep_dev/ep_bcast.cpp	(revision 1289)
@@ -11,8 +11,40 @@
 #include "ep_mpi.hpp"
 
+
 using namespace std;
+
 
 namespace ep_lib
 {
+
+  int MPI_Bcast_local(void *buffer, int count, MPI_Datatype datatype, int local_root, MPI_Comm comm)
+  {
+    assert(valid_type(datatype));
+
+    int ep_rank_loc = comm.ep_comm_ptr->size_rank_info[1].first;
+
+    ::MPI_Aint datasize, lb;
+    ::MPI_Type_get_extent(to_mpi_type(datatype), &lb, &datasize);
+    
+
+    if(ep_rank_loc == local_root)
+    {
+      //comm.ep_comm_ptr->comm_list->collective_buffer[local_root] = buffer;
+      comm.my_buffer->void_buffer[local_root] = buffer;
+    }
+
+//    #pragma omp flush
+    MPI_Barrier_local(comm);
+//    #pragma omp flush
+
+    if(ep_rank_loc != local_root)
+    {
+      #pragma omp critical (_bcast)      
+      memcpy(buffer, comm.my_buffer->void_buffer[local_root], datasize * count);
+      //memcpy(buffer, comm.ep_comm_ptr->comm_list->collective_buffer[local_root], datasize * count);
+    }
+
+    MPI_Barrier_local(comm);
+  }
 
   int MPI_Bcast(void *buffer, int count, MPI_Datatype datatype, int root, MPI_Comm comm)
@@ -49,31 +81,296 @@
 
 
-  int MPI_Bcast_local(void *buffer, int count, MPI_Datatype datatype, int local_root, MPI_Comm comm)
-  {
-    assert(valid_type(datatype));
-
-    int ep_rank_loc = comm.ep_comm_ptr->size_rank_info[1].first;
-
-    ::MPI_Aint datasize, lb;
-    ::MPI_Type_get_extent(to_mpi_type(datatype), &lb, &datasize);
-    
-
-    if(ep_rank_loc == local_root)
-    {
-      comm.my_buffer->void_buffer[local_root] = buffer;
-    }
-
-//    #pragma omp flush
-    MPI_Barrier_local(comm);
-//    #pragma omp flush
-
-    if(ep_rank_loc != local_root)
-    {
-      #pragma omp critical (_bcast)      
-      memcpy(buffer, comm.my_buffer->void_buffer[local_root], datasize * count);
-    }
-
-    MPI_Barrier_local(comm);
-  }
+
+
+
+  int MPI_Bcast_local2(void *buffer, int count, MPI_Datatype datatype, MPI_Comm comm)
+  {
+    if(datatype == MPI_INT)
+    {
+      return MPI_Bcast_local_int(buffer, count, comm);
+    }
+    else if(datatype == MPI_FLOAT)
+    {
+      return MPI_Bcast_local_float(buffer, count, comm);
+    }
+    else if(datatype == MPI_DOUBLE)
+    {
+      return MPI_Bcast_local_double(buffer, count, comm);
+    }
+    else if(datatype == MPI_CHAR)
+    {
+      return MPI_Bcast_local_char(buffer, count, comm);
+    }
+    else if(datatype == MPI_LONG)
+    {
+      return MPI_Bcast_local_long(buffer, count, comm);
+    }
+    else if(datatype == MPI_UNSIGNED_LONG)
+    {
+      return MPI_Bcast_local_char(buffer, count, comm);
+    }
+    else
+    {
+      printf("MPI_Bcast Datatype not supported!\n");
+      exit(0);
+    }
+  }
+
+  int MPI_Bcast_local_int(void *buf, int count, MPI_Comm comm)
+  {
+    int my_rank = comm.ep_comm_ptr->size_rank_info[1].first;
+    int num_ep  = comm.ep_comm_ptr->size_rank_info[1].second;
+
+    int *buffer = comm.my_buffer->buf_int;
+    int *tmp = static_cast<int*>(buf);
+
+    for(int j=0; j<count; j+=BUFFER_SIZE)
+    {
+      if(my_rank == 0)
+      {
+        #pragma omp critical (write_to_buffer)
+        {
+          copy(tmp+j, tmp+j+min(BUFFER_SIZE, count-j), buffer);
+        }
+        #pragma omp flush
+      }
+
+      MPI_Barrier_local(comm);
+
+
+
+      if(my_rank != 0)
+      {
+        #pragma omp flush
+        #pragma omp critical (read_from_buffer)
+        {
+          copy(buffer, buffer+min(BUFFER_SIZE, count-j), tmp+j);
+        }
+      }
+
+      MPI_Barrier_local(comm);
+    }
+  }
+
+  int MPI_Bcast_local_float(void *buf, int count, MPI_Comm comm)
+  {
+    int my_rank = comm.ep_comm_ptr->size_rank_info[1].first;
+    int num_ep  = comm.ep_comm_ptr->size_rank_info[1].second;
+
+    float *buffer = comm.my_buffer->buf_float;
+    float *tmp = static_cast<float*>(buf);
+
+    for(int j=0; j<count; j+=BUFFER_SIZE)
+    {
+      if(my_rank == 0)
+      {
+        #pragma omp critical (write_to_buffer)
+        {
+          copy(tmp+j, tmp+j+min(BUFFER_SIZE, count-j), buffer);
+        }
+        #pragma omp flush
+      }
+
+      MPI_Barrier_local(comm);
+
+
+      if(my_rank != 0)
+      {
+        #pragma omp flush
+        #pragma omp critical (read_from_buffer)
+        {
+          copy(buffer, buffer+min(BUFFER_SIZE, count-j), tmp+j);
+        }
+      }
+
+      MPI_Barrier_local(comm);
+    }
+  }
+
+  int MPI_Bcast_local_double(void *buf, int count, MPI_Comm comm)
+  {
+    int my_rank = comm.ep_comm_ptr->size_rank_info[1].first;
+    int num_ep  = comm.ep_comm_ptr->size_rank_info[1].second;
+
+    double *buffer = comm.my_buffer->buf_double;
+    double *tmp = static_cast<double*>(buf);
+
+    for(int j=0; j<count; j+=BUFFER_SIZE)
+    {
+      if(my_rank == 0)
+      {
+        #pragma omp critical (write_to_buffer)
+        {
+          copy(tmp+j, tmp+j+min(BUFFER_SIZE, count-j), buffer);
+        }
+        #pragma omp flush
+      }
+
+      MPI_Barrier_local(comm);
+
+
+      if(my_rank != 0)
+      {
+        #pragma omp flush
+        #pragma omp critical (read_from_buffer)
+        {
+          copy(buffer, buffer+min(BUFFER_SIZE, count-j), tmp+j);
+        }
+      }
+
+      MPI_Barrier_local(comm);
+    }
+  }
+
+
+  int MPI_Bcast_local_char(void *buf, int count, MPI_Comm comm)
+  {
+    int my_rank = comm.ep_comm_ptr->size_rank_info[1].first;
+    int num_ep  = comm.ep_comm_ptr->size_rank_info[1].second;
+
+    char *buffer = comm.my_buffer->buf_char;
+    char *tmp = static_cast<char*>(buf);
+
+    for(int j=0; j<count; j+=BUFFER_SIZE)
+    {
+      if(my_rank == 0)
+      {
+        #pragma omp critical (write_to_buffer)
+        {
+          copy(tmp+j, tmp+j+min(BUFFER_SIZE, count-j), buffer);
+        }
+        #pragma omp flush
+      }
+
+      MPI_Barrier_local(comm);
+
+
+      if(my_rank != 0)
+      {
+        #pragma omp flush
+        #pragma omp critical (read_from_buffer)
+        {
+          copy(buffer, buffer+min(BUFFER_SIZE, count-j), tmp+j);
+        }
+      }
+
+      MPI_Barrier_local(comm);
+    }
+  }
+
+  int MPI_Bcast_local_long(void *buf, int count, MPI_Comm comm)
+  {
+    int my_rank = comm.ep_comm_ptr->size_rank_info[1].first;
+    int num_ep  = comm.ep_comm_ptr->size_rank_info[1].second;
+
+    long *buffer = comm.my_buffer->buf_long;
+    long *tmp = static_cast<long*>(buf);
+
+    for(int j=0; j<count; j+=BUFFER_SIZE)
+    {
+      if(my_rank == 0)
+      {
+        #pragma omp critical (write_to_buffer)
+        {
+          copy(tmp+j, tmp+j+min(BUFFER_SIZE, count-j), buffer);
+        }
+        #pragma omp flush
+      }
+
+      MPI_Barrier_local(comm);
+
+
+      if(my_rank != 0)
+      {
+        #pragma omp flush
+        #pragma omp critical (read_from_buffer)
+        {
+          copy(buffer, buffer+min(BUFFER_SIZE, count-j), tmp+j);
+        }
+      }
+
+      MPI_Barrier_local(comm);
+    }
+  }
+
+  int MPI_Bcast_local_ulong(void *buf, int count, MPI_Comm comm)
+  {
+    int my_rank = comm.ep_comm_ptr->size_rank_info[1].first;
+    int num_ep  = comm.ep_comm_ptr->size_rank_info[1].second;
+
+    unsigned long *buffer = comm.my_buffer->buf_ulong;
+    unsigned long *tmp = static_cast<unsigned long*>(buf);
+
+    for(int j=0; j<count; j+=BUFFER_SIZE)
+    {
+      if(my_rank == 0)
+      {
+        #pragma omp critical (write_to_buffer)
+        {
+          copy(tmp+j, tmp+j+min(BUFFER_SIZE, count-j), buffer);
+        }
+        #pragma omp flush
+      }
+
+      MPI_Barrier_local(comm);
+
+
+      if(my_rank != 0)
+      {
+        #pragma omp flush
+        #pragma omp critical (read_from_buffer)
+        {
+          copy(buffer, buffer+min(BUFFER_SIZE, count-j), tmp+j);
+        }
+      }
+
+      MPI_Barrier_local(comm);
+    }
+  }
+
+
+  int MPI_Bcast2(void *buffer, int count, MPI_Datatype datatype, int root, MPI_Comm comm)
+  {
+
+    if(!comm.is_ep)
+    {
+      ::MPI_Bcast(buffer, count, static_cast< ::MPI_Datatype>(datatype), root, static_cast< ::MPI_Comm>(comm.mpi_comm));
+      return 0;
+    }
+
+
+    int ep_rank, ep_rank_loc, mpi_rank;
+    int ep_size, num_ep, mpi_size;
+
+    ep_rank = comm.ep_comm_ptr->size_rank_info[0].first;
+    ep_rank_loc = comm.ep_comm_ptr->size_rank_info[1].first;
+    mpi_rank = comm.ep_comm_ptr->size_rank_info[2].first;
+    ep_size = comm.ep_comm_ptr->size_rank_info[0].second;
+    num_ep = comm.ep_comm_ptr->size_rank_info[1].second;
+    mpi_size = comm.ep_comm_ptr->size_rank_info[2].second;
+
+
+
+    int root_mpi_rank = comm.rank_map->at(root).second;
+    int root_ep_rank_loc = comm.rank_map->at(root).first;
+
+
+    // if root is not master thread, send first to master
+    if(root_ep_rank_loc != 0 && mpi_rank == root_mpi_rank)
+    {
+      innode_memcpy(root_ep_rank_loc, buffer, 0, buffer, count, datatype, comm);
+    }
+
+
+    if(ep_rank_loc==0)
+    {
+      ::MPI_Bcast(buffer, count, static_cast< ::MPI_Datatype>(datatype), root_mpi_rank, static_cast< ::MPI_Comm>(comm.mpi_comm));
+    }
+
+    MPI_Bcast_local2(buffer, count, datatype, comm);
+
+    return 0;
+  }
+
 
 }
Index: XIOS/dev/branch_openmp/extern/src_ep_dev/ep_create.cpp
===================================================================
--- XIOS/dev/branch_openmp/extern/src_ep_dev/ep_create.cpp	(revision 1288)
+++ XIOS/dev/branch_openmp/extern/src_ep_dev/ep_create.cpp	(revision 1289)
@@ -63,10 +63,10 @@
 
     out_comm_hdls[0].my_buffer = new BUFFER;
-    // out_comm_hdls[0].my_buffer->buf_double = new double[BUFFER_SIZE];
-    // out_comm_hdls[0].my_buffer->buf_float  = new float[BUFFER_SIZE];
-    // out_comm_hdls[0].my_buffer->buf_int    = new int[BUFFER_SIZE];
-    // out_comm_hdls[0].my_buffer->buf_long   = new long[BUFFER_SIZE];
-    // out_comm_hdls[0].my_buffer->buf_ulong  = new unsigned long[BUFFER_SIZE];
-    // out_comm_hdls[0].my_buffer->buf_char   = new char[BUFFER_SIZE];
+    out_comm_hdls[0].my_buffer->buf_double = new double[BUFFER_SIZE];
+    out_comm_hdls[0].my_buffer->buf_float  = new float[BUFFER_SIZE];
+    out_comm_hdls[0].my_buffer->buf_int    = new int[BUFFER_SIZE];
+    out_comm_hdls[0].my_buffer->buf_long   = new long[BUFFER_SIZE];
+    out_comm_hdls[0].my_buffer->buf_ulong  = new unsigned long[BUFFER_SIZE];
+    out_comm_hdls[0].my_buffer->buf_char   = new char[BUFFER_SIZE];
 
     out_comm_hdls[0].rank_map = new RANK_MAP;
@@ -145,10 +145,10 @@
 
     out_comm_hdls[0].my_buffer = new BUFFER;
-    // out_comm_hdls[0].my_buffer->buf_double = new double[BUFFER_SIZE];
-    // out_comm_hdls[0].my_buffer->buf_float  = new float[BUFFER_SIZE];
-    // out_comm_hdls[0].my_buffer->buf_int    = new int[BUFFER_SIZE];
-    // out_comm_hdls[0].my_buffer->buf_long   = new long[BUFFER_SIZE];
-    // out_comm_hdls[0].my_buffer->buf_ulong  = new unsigned long[BUFFER_SIZE];
-    // out_comm_hdls[0].my_buffer->buf_char   = new char[BUFFER_SIZE];
+    out_comm_hdls[0].my_buffer->buf_double = new double[BUFFER_SIZE];
+    out_comm_hdls[0].my_buffer->buf_float  = new float[BUFFER_SIZE];
+    out_comm_hdls[0].my_buffer->buf_int    = new int[BUFFER_SIZE];
+    out_comm_hdls[0].my_buffer->buf_long   = new long[BUFFER_SIZE];
+    out_comm_hdls[0].my_buffer->buf_ulong  = new unsigned long[BUFFER_SIZE];
+    out_comm_hdls[0].my_buffer->buf_char   = new char[BUFFER_SIZE];
 
     out_comm_hdls[0].rank_map = new RANK_MAP;
@@ -233,10 +233,10 @@
 
     out_comm_hdls[0].my_buffer = new BUFFER;
-    // out_comm_hdls[0].my_buffer->buf_double = new double[BUFFER_SIZE];
-    // out_comm_hdls[0].my_buffer->buf_float  = new float[BUFFER_SIZE];
-    // out_comm_hdls[0].my_buffer->buf_int    = new int[BUFFER_SIZE];
-    // out_comm_hdls[0].my_buffer->buf_long   = new long[BUFFER_SIZE];
-    // out_comm_hdls[0].my_buffer->buf_ulong  = new unsigned long[BUFFER_SIZE];
-    // out_comm_hdls[0].my_buffer->buf_char   = new char[BUFFER_SIZE];
+    out_comm_hdls[0].my_buffer->buf_double = new double[BUFFER_SIZE];
+    out_comm_hdls[0].my_buffer->buf_float  = new float[BUFFER_SIZE];
+    out_comm_hdls[0].my_buffer->buf_int    = new int[BUFFER_SIZE];
+    out_comm_hdls[0].my_buffer->buf_long   = new long[BUFFER_SIZE];
+    out_comm_hdls[0].my_buffer->buf_ulong  = new unsigned long[BUFFER_SIZE];
+    out_comm_hdls[0].my_buffer->buf_char   = new char[BUFFER_SIZE];
 
     out_comm_hdls[0].rank_map = new RANK_MAP;
Index: XIOS/dev/branch_openmp/extern/src_ep_dev/ep_exscan.cpp
===================================================================
--- XIOS/dev/branch_openmp/extern/src_ep_dev/ep_exscan.cpp	(revision 1288)
+++ XIOS/dev/branch_openmp/extern/src_ep_dev/ep_exscan.cpp	(revision 1289)
@@ -9,5 +9,4 @@
 #include <mpi.h>
 #include "ep_declaration.hpp"
-#include "ep_mpi.hpp"
 
 using namespace std;
